/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lem_in.c                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: mndhlovu <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/03/25 06:31:05 by mndhlovu          #+#    #+#             */
/*   Updated: 2019/05/02 14:26:13 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "lem_in.h"

void		lm_test_print(t_lmdata *data)
{
	t_node		*node;

	if (data != NULL)
	{
		node = data->nodes_data;
		while (node)
		{
			ft_printf("name: %s | x: %d | y: %d | role: %c \n", node->name, node->x, node->y, node->role);
			node = node->next;
		}
	}
}

static int		start_end_link(t_lmdata *data, int s_ind, int e_ind)
{
	t_ind	*it;

	it = data->adj[s_ind];
	while (it)
	{
		if (it->index == e_ind)
			return (1);
		it = it->next;
	}
	return (0);
}

static int		lem_in(t_syntax *synt, t_holder *holder,
						t_lmdata *lmdata, t_ind ***ret)
{
	lm_parser(synt, lmdata, holder);
	if (!lm_verify_cmd(synt, holder, lmdata))
		return (0);
	if (!lst_indinit(lmdata))
		return (0);
	if ((lm_adj_parser(lmdata, holder) == 0))
		return (0);
	print_map(lmdata);
	lm_clear_unv(holder, lmdata);
	if (start_end_link(lmdata, get_node_role(lmdata, 's')->ind
					   , get_node_role(lmdata, 'e')->ind))
		push_ants_end(lmdata, get_node_role(lmdata, 'e')->name);
	else
	{
		get_nb_paths_max(lmdata, get_node_role(lmdata, 's')->ind
						 , get_node_role(lmdata, 'e')->ind);
		if ((*ret = edmonds_karp(lmdata, get_node_role(lmdata, 's')->ind
 								 , get_node_role(lmdata, 'e')->ind)) == NULL)
			return (0);
		if (!push_ants(lmdata, *ret, get_nb_paths(*ret)))
			return (0);
		tablst_inddel(*ret);
	}
	return (1);
}

static int		lm_error_exit(void)
{
	ft_putendl_fd("ERROR", 2);
	return (1);
}

int				main(int ac, char **av)
{
	t_syntax	synt;
	t_lmdata	ldata;
	t_holder	holder;
	t_ind		**ret;

	(void)av;
	if (ac == 1)
	{
		lm_init_data(&synt, &holder, &ldata);
		if (!(lem_in(&synt, &holder, &ldata, &ret)))
		{
			lm_clean_data(&ldata);
			del_map(&ldata);
			return (lm_error_exit());
		}
		del_map(&ldata);
		lm_clean_data(&ldata);
		return (0);
	}
	return (1);
}
